﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace FetchAIP
{
    class Download
    {
        public int DownloadAIP(BackgroundWorker bwDownloader, string baseURL, Queue<pdfLinks> pdfs, string outputPath)
        {
            int pdfsDownloaded = 0;
            // Download pdfs
            foreach (var pdf in pdfs)
            {
                if (bwDownloader.CancellationPending)
                {
                    break;
                }

                string subFolderName;

                var client = new WebClient();

                Byte[] pdfData = client.DownloadData(baseURL + pdf.FileURL);

                pdfsDownloaded++;

                int slashIndex = pdf.FileURL.IndexOf("/") + 1;

                // subFolderName = "";

                if (pdf.FileURL.StartsWith("pdf/NZ"))
                {
                    subFolderName = "Airport charts\\" + pdf.FileURL.Substring(slashIndex, 4);
                }
                else if (pdf.FileURL.StartsWith("pdf/GEN"))
                {
                    subFolderName = "_AIP_GEN";
                }
                else if (pdf.FileURL.StartsWith("pdf/ENR"))
                {
                    subFolderName = "_AIP_ENR";
                }
                else if (pdf.FileURL.StartsWith("pdf/AD"))
                {
                    subFolderName = "_AIP_AD1";
                }
                else if (pdf.FileURL.StartsWith("pdf/sup"))
                {
                    subFolderName = "_AIP_SUP";
                }
                else
                {
                    subFolderName = "_AIP_UNKNOWN";
                }

                if (!Directory.Exists(outputPath + "\\" + subFolderName))
                    Directory.CreateDirectory(outputPath + "\\" + subFolderName);

                if (pdf.FileURL.Contains("supplements"))
                {
                    File.WriteAllBytes(outputPath + "\\" + subFolderName + "\\" + pdf.FileURL.Replace("pdf/supplements/", string.Empty), pdfData);
                }
                else
                {
                    File.WriteAllBytes(outputPath + "\\" + subFolderName + "\\" + pdf.FileURL.Replace("pdf/", string.Empty), pdfData);
                }
                int pctComplete = (int)(((double)pdfsDownloaded / (double)pdfs.Count()) * 100);
                bwDownloader.ReportProgress(pctComplete);
            }
            return pdfs.Count;
        }
    }
}
